#pragma once

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <vector>
#include "MQBasePlugin.h"
#include "MQSetting.h"

class VertexBasedKnife : public MQCommandPlugin
{
private:
	static VertexBasedKnife *singleton_;
	MQDocument document_;
	BOOL bActive_;
	BOOL bSnaped_;
	BOOL bMoved_;
	MQSelectVertex highlightVertex_;
	MQSelectVertex baseVertex_;
	MQSelectVertex endVertex_;
	MQPoint baseScreenPos_;
	MQPoint endScreenPos_;

public:
	static VertexBasedKnife* GetInstance();
	static void DeleteInstance();

	// vOCIDԂB
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// vOCԂB
	virtual const char *GetPlugInName();
	// |bvAbvj[ɕ\镶ԂB
	virtual const char *EnumString();
	// AvP[V̏
	virtual BOOL Initialize();
	// AvP[V̏I
	virtual void Exit();
	// hLg
	virtual void OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param);
	// \E\؂ւv
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// `掞̏
	virtual void OnDraw(MQDocument doc, MQScene scene, int width, int height);
	// {^ꂽƂ
	virtual BOOL OnLeftButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// {^ꂽƂ
	virtual BOOL OnLeftButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// {^Ȃ}EXړƂ
	virtual BOOL OnLeftButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// }EXړƂ
	virtual BOOL OnMouseMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);

private:
	VertexBasedKnife();
	VertexBasedKnife( const VertexBasedKnife& p );
	~VertexBasedKnife();

	MQSelectVertex GetNearbyVertex(MQScene scene, POINT screenPos, float range, BOOL currentObjectOnly);
	bool ExecKnifeCut(MQDocument doc, MQScene scene, MQPoint tsv1, MQPoint tsv2, MQSelectVertex kv1, MQSelectVertex kv2);
	MQSelectFace GetCommonFace(MQSelectVertex v1, MQSelectVertex v2);
};

